package jace.apple2e.softswitch;

import jace.core.Computer;
import jace.core.RAMEvent;
import jace.core.SoftSwitch;

/**
 *
 * @author blurry
 */
public class MemorySoftSwitch extends SoftSwitch {
    
    public MemorySoftSwitch(String name, int offAddress, int onAddress, int queryAddress, RAMEvent.TYPE changeType, Boolean initalState) {
        super(name,offAddress,onAddress,queryAddress,changeType,initalState);
    }

    public MemorySoftSwitch(String name, int[] offAddrs, int[] onAddrs, int[] queryAddrs, RAMEvent.TYPE changeType, Boolean initalState) {
        super(name,offAddrs,onAddrs,queryAddrs,changeType,initalState);
    }
    
    public void stateChanged() {
//        System.out.println(getName()+ " was switched to "+getState());
        Computer.getComputer().getMemory().configureActiveMemory();
    }

    // Todo: Implement floating bus, maybe?
    protected byte readSwitch() {
        return (byte) (getState()?0x0A0:0x020);
    }
}