package jace.apple2e.softswitch;

import jace.core.Computer;
import jace.core.RAMEvent;
import jace.core.SoftSwitch;

/**
 *
 * @author blurry
 */
public class VideoSoftSwitch extends SoftSwitch {
    
    public VideoSoftSwitch(String name, int offAddress, int onAddress, int queryAddress, RAMEvent.TYPE changeType, Boolean initalState) {
        super(name,offAddress,onAddress,queryAddress,changeType,initalState);
    }

    public VideoSoftSwitch(String name, int[] offAddrs, int[] onAddrs, int[] queryAddrs, RAMEvent.TYPE changeType, Boolean initalState) {
        super(name,offAddrs,onAddrs,queryAddrs,changeType,initalState);
    }
    
    public void stateChanged() {
//        System.out.println("Set "+getName()+" -> "+getState());
        Computer.getComputer().getVideo().configureVideoMode();
    }
    
    protected byte readSwitch() {
//        System.out.println("Read "+getName()+" = "+getState());
        return (byte) (getState()?0x080:0x000);
    }
}
