/*
 * NoiseGenerator.java
 *
 * Created on April 18, 2006, 5:47 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package jace.hardware.mockingboard;

public class NoiseGenerator extends TimedGenerator {
    int rng = 0x003333;
    public NoiseGenerator(int _clock,int _sampleRate) {
        super(_clock, _sampleRate);
    }
    public int stepsPerCycle() {
        return 8;
    }
    public void step() {
        int stateChanges = updateCounter();
        for (int i=0; i < stateChanges; i++)
            updateRng();
    }
    public static final int bit17 = 0x010000;
    public void updateRng() {
        int newBit17 = (rng & 0x04) > 0 == (rng & 0x01) > 0 ? bit17 : 0;
        rng = newBit17 + (rng >> 1);
    }
    public boolean isOn() {
        return ((rng & 1) == 1);
    }
}