/*
 * Debugger.java
 *
 * Created on April 16, 2007, 10:37 PM
 */

package jace.core;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author Administrator
 */
public abstract class Debugger {
    public abstract void updateStatus();
    private boolean active = false;
    public boolean step = false;    
    public void setActive(boolean state) {
        active = state;
    }
    public boolean isActive() {
        return active;
    }
    private List<Integer> breakpoints = new ArrayList<Integer>();
    public List<Integer> getBreakpoints() {return breakpoints;}

    private boolean hasBreakpoints = false;
    boolean hasBreakpoints() {
        return hasBreakpoints;
    }
    public void updateBreakpoints() {
        hasBreakpoints = false;
        for (Integer i : breakpoints)
            if (i != null) hasBreakpoints = true;
    }

    boolean takeStep() {
        if (step) {
            step = false;
            return true;
        }
        return false;
    }
}
