/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jace.hardware.massStorage;

import java.io.File;
import java.io.IOException;

/**
 *
 * @author brobert
 */
public interface IDisk {
    public static int BLOCK_SIZE = 512;
    public static int MAX_BLOCK = 65535;

    public void mliFormat() throws IOException;
    public void mliRead(int block, int bufferAddress) throws IOException;
    public void mliWrite(int block, int bufferAddress) throws IOException;
    public void boot0(int slot) throws IOException;

    public File getPhysicalPath();
    public void setPhysicalPath(File f) throws IOException;
    public void eject();
    public boolean isWriteProtected();
    // Return size in 512k blocks
    public int getSize();
}
