/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package jace.hardware.massStorage;

import java.io.IOException;

/**
 *
 * @author brobert
 */
public class SubNode extends DiskNode {
    int sequenceNumber;
    private int seq;

    public SubNode(int seq, DiskNode parent) throws IOException {
        init(seq, parent);
    }

    public SubNode(int seq, DiskNode parent, int baseBlock) throws IOException {
        setBaseBlock(baseBlock);
        init(seq, parent);
    }

    private void init(int seq, DiskNode parent) throws IOException {
        sequenceNumber=seq;
        setParent(parent);
        setOwnerFilesystem(parent.getOwnerFilesystem());
        parent.additionalNodes.add(this);
    }

    @Override
    public void doDeallocate() {
    }

    @Override
    public void doAllocate() {
    }

    @Override
    public void doRefresh() {
    }

    @Override
    public void readBlock(int sequence, byte[] buffer) throws IOException {
        parent.readBlock(sequenceNumber, buffer);
    }
}
